#pragma once

#include"base.h"
#include<cstdio>
#include<algorithm>

class online_adversary : public adversary
{
 public:   
    void send(vector<int> locations)
    {
        replies.push_back(get_reply(locations));     
    }

    vector<int> wait()
    {
        vector<int> result = replies; replies.clear();
        return result;
    }

 protected:
    virtual int get_reply(vector<int>) = 0;
    
 private:
    vector<int> replies;
};
