#pragma once

#include"online.h"
#include<algorithm>
#include<cassert>

class fixed_adversary : public online_adversary
{
 public:
    fixed_adversary(int _a, int _b) : a(_a), b(_b)
    {
        if(a > b) swap(a, b);
    }

    bool answer(int x, int y)
    {
        if(x > y) swap(x, y);
        return x == a and y == b;   
    }

 protected:
    int get_reply(vector<int> locations)
    {
        for(int x : locations)
            if(x == a or x == b)
                return 1;    

        return 0;
    }
    
 private:
    int a, b;
};
